Bug 55355 - 2.4.9-6 emu10k1 driver hangs entire machine
2.4.9-6 emu10k1 driver hangs entire machine
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Arjan van de Ven
Brock Organ
Depends On:
  Show dependency treegraph
Reported: 2001-10-30 01:23 EST by James Ralston
Modified: 2007-04-18 12:37 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2002-07-16 15:42:49 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description James Ralston 2001-10-30 01:23:29 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.4) Gecko/20010917

Description of problem:
I have a Creative Labs Soundblaster Live card in my system, which worked
under kernel-2.4.3-12.  I'm using enlightenment as my WM and have sounds
enabled, so when I'm running X, my computer is playing sounds frequently.

When I upgraded to kernel-2.4.9-6, whenever a sound would stop playing, I
would sometimes hear a short a burst of (what appeared to be) static. 
Occasionally, my entire system would completely hang, wedging itself
abruptly and completely.  (The keyboard would be completely unresponsive,
it wouldn't respond to IP packets, etc.)  The hangs seemed to happen right
after my system finished playing a sound.  I might have been able to get
away without a hang for an hour or two, but over a significant period of
time (e.g. 4-5 hours), I would always see a hang.

A few days ago, I had unconfigured my sound card, so that neither the
soundcore nor the emu10k1 drivers were loaded.  I haven't had one single
hang since that time, and I spent about 6 hours performing a stress test
(simultaneously recompiling the kernel, ripping CDs, and running a very
active gnutella client).

I strongly suspect that the kernel-2.4.9-6 emu10k1 driver and/or soundcore
driver is buggy.  Or, at the minimum, it doesn't do as good of a job at
keeping the SB Live hardware from messing up things:


I intend to replace my SB Live with a Turtle Beach Santa Cruz; after I've
done that, I'll see if I still get static/hangs.

Still, if there's any way to tweak the existing emu10k1 driver, it would
probably be a good idea.  (I never ran into problems under kernel-2.4.3-12.)

I don't know how easy it will be to reproduce this problem, as it might
depend on the specific hardware I have in my system.  Your best shot to
reproduce is probably to use a system with a SB Live card, and make sure
your window manager plays sounds for various actions.  If you can get it to
generate the static bursts, you'll probably see a hang.
Comment 1 Ed Bailey 2001-10-30 12:13:01 EST
This is very similar to what I'm experiencing.  FWIW, I was able to run
2.4.9-0.5 from Rawhide without hangs, although it would garble the sounds
Comment 2 Ed Bailey 2001-11-05 10:51:29 EST
Ok, a bit more info.  The problem is definitely related to the emu10k driver, as
I was able to run for extended periods of time without a hang if I disabled all
window-manager sounds (which forms the vast majority of my sound usage).

I then noticed that my sound card and my NIC were sharing an interrupt. 
Thinking that this might be related to the problem, I moved the sound card to
give it its own IRQ (damn crappy Dell bios!).  The result: a hard hang within
five minutes of enabling window manager sounds.  FWIW, the sounds are also still

Comment 3 James Ralston 2001-11-12 23:41:11 EST
Ok, some more info...

I went and grabbed the 2001-11-01 snapshot of the emu10k1 driver:


I've been running this on both my home machine (custom-built) and my work
machine (a Dell box) since November 1.

The good news: I haven't experienced any hard system hangs using this snapshot

The bad news: I still occasionally get garbled sounds.  I'm not certain, but the
incidents of garbling seem to appear less frequently the longer I'm using the
machine.  (Right after I start up an X session, I get garbled sounds fairly
frequently, but after an hour or so, I hardly seem to get any.)

I experienced neither hangs nor garbling under 2.4.3.
Comment 4 James Ralston 2002-01-02 18:20:45 EST
Since I submitted this bug report, I've upgraded all of my machines to Red Hat
7.2, and I still get garbled sounds, static, etc.

I don't remember now if I had any lockups using the stock emu10k driver that
came with 7.2; as soon as I determined that the static/garbling problem was
still there, I went and grabbed the 2001-11-19 snapshot from Creative's web site
and installed those modules.

Has there been any progress on this?

Honestly, for my home machine, I'll just replace the sound card.  But the
Soundblaster Live cards are popular cards; there needs to be some better
resolution to this problem than "replace your sound card".  (For example, at
work, we have hundreds of Dell PCs with Soundblaster Live cards in 'em.)
Comment 5 Arjan van de Ven 2002-02-11 12:37:42 EST
The 2.4.9-21 kernel we shipped has an "experimental" emu10k1 driver in it,
called emu10k1_new. Several people say that this fixed quite a few problems for
Comment 6 Ed Bailey 2002-02-13 11:01:08 EST
Yup, the _new module seems to have fixed it (modulo the occasional burst of
noise when a sound first starts playing)...
Comment 7 James Ralston 2002-03-06 00:59:02 EST
I haven't had any hangs or lockups with the emu10k1_new module, and I've been
banging on it for about a month now.

I still get occasional bursts of static, noise, pops, and so forth, though.  I
suspect the crappy Soundblaster hardware is to blame, and that the old (kernel
2.2.* and 2.4.3) drivers were doing something to hack around the sound card's

I'd suggest phasing in the experimental "emu10k1_new" driver sooner rather than
later, if you can.  The evidence that the existing emu10k1 driver is busted is
fairly convincing...
Comment 8 Bryce Nesbitt 2002-03-22 14:07:09 EST
Confirmed:  I have similar problems

HardHat:audio> cat /etc/modules.conf
alias sound-slot-0 emu10k1

HardHat:audio> uname -a
Linux HardHat 2.4.9-21 #1 Thu Jan 17 13:35:37 EST 2002 i686 unknown

Since upgrading to 2.5.9 I've had huge audio problems.  100% of the time I get
very bad
glitches when sound is used after a quiet period.  Sometimes audio plays back
fine after
the glitch, sometimes
I get terrible noise instead of audio.
Comment 9 James Ralston 2002-07-16 15:42:44 EDT
After extensive use, I've concluded that the emu10k1 module in Red Hat 7.3 works
around the Soundblaster Live problems.  After several months of use, I've yet to
encounter a single hang, or even any audio distortion at all.

If anyone monitoring this bug believes otherwise, then speak up; if I don't see
any feedback before the end of the week, I'm going to close this bug with

Note You need to log in before you can comment on or make changes to this bug.